:
# NAME:
#	scm-funcs.sh - scm wrapper funcs
#

# RCSid:
#	$Id: scm-funcs.sh,v 1.1 2021/01/13 06:13:35 sjg Exp $
#
#	@(#) Copyright (c) 2020 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

get_SCM() {
    for d in . $SB_SRC $SB/src
    do
        for clue in CVS/Entries .hg .svn .git 
	do
            test -s $d/$clue || continue
            case "$clue" in
	    CVS/*) echo cvs; return;;
	    .*) echo ${clue#.}; return;;
	    esac
	done
    done
}

SCM=${SB_SCM:-${SCM:-`get_SCM`}}
SCM_VAR=`echo $SCM | tr '[a-z]' '[A-Z]'`
eval SCM_CMD=\${$SCM_VAR:-$SCM}
PAGER=${PAGER:-more}

scm_op() {
    $SCM_CMD "$@" | ${PAGER}
}

scm_ops() {
    op=$1; shift
    for f in "$@"
    do
        scm_op $op $f || break
    done
}

case "$SCM" in
git|hg) ;;
*)
    for op in log diff
    do
        eval "${SCM}_$op() { scm_op $op \"\$@\"; }"
        eval "${SCM}_${op}s() { scm_ops $op \"\$@\"; }"
    done
    ;;
esac

    
